unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, uLoginDlg, uSecControl, uFormPolicy, Menus, uSecDlg,
  StdCtrls, ExtCtrls, Grids, DBGrids, DBISAMTb;

type
  TForm1 = class(TForm)
    dsGroups: TDataSource;
    dsGroupAccess: TDataSource;
    dsGroupMembership: TDataSource;
    dsPermissions: TDataSource;
    dsUsers: TDataSource;
    dsUserAccess: TDataSource;
    uilSecurityManager1: TuilSecurityManager;
    uilLoginDlg1: TuilLoginDlg;
    uilSecurityDlg1: TuilSecurityDlg;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Tools1: TMenuItem;
    UserManagement1: TMenuItem;
    New1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    SaveAs1: TMenuItem;
    N1: TMenuItem;
    Spelling1: TMenuItem;
    N2: TMenuItem;
    uilFormPolicy1: TuilFormPolicy;
    Shape1: TShape;
    Shape2: TShape;
    Shape3: TShape;
    Shape4: TShape;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Shape5: TShape;
    Label10: TLabel;
    Shape6: TShape;
    Label11: TLabel;
    Login1: TMenuItem;
    Login2: TMenuItem;
    Logout1: TMenuItem;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    dbPermissions: TDBISAMTable;
    dbGroupMembership: TDBISAMTable;
    dbGroupAccess: TDBISAMTable;
    dbGroups: TDBISAMTable;
    dbUserAccess: TDBISAMTable;
    dbUsers: TDBISAMTable;
    Edit1: TMenuItem;
    Copy1: TMenuItem;
    DBISAMDatabase1: TDBISAMDatabase;
    procedure FormCreate(Sender: TObject);
    procedure uilSecurityManager1FailedLogin(Sender: TObject);
    procedure UserManagement1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Login2Click(Sender: TObject);
    procedure Logout1Click(Sender: TObject);
    procedure uilSecurityManager1DisabledLogin(Sender: TObject;
      UserName: String);
    procedure EditCopy1Execute(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
   APath : string;
begin
   // Get the path to the data
   APath := ExtractFilePath(Application.ExeName);
   if APath[Length(APath)] <> '\' then
      APath := APath + '\';
   APath := APath + 'Data';

   // Set the database name
   DBISAMDatabase1.Directory := APath;

   // Let everyone know how to get into the demo!
   ShowMessage('To login, the username is admin with no password.');

   // Open the tables
   dbGroups.Open;
   dbGroupAccess.Open;
   dbGroupMembership.Open;
   dbUsers.Open;
   dbUserAccess.Open;
   dbPermissions.Open;

   // Login to the Security Manager...
   if not uilLoginDlg1.Execute then
     Application.Terminate;
end;

procedure TForm1.uilSecurityManager1FailedLogin(Sender: TObject);
begin
   ShowMessage('Login failed!');
end;

procedure TForm1.UserManagement1Click(Sender: TObject);
begin
   uilSecurityDlg1.Execute;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
   Close;
end;

procedure TForm1.Login2Click(Sender: TObject);
begin
   uilLoginDlg1.Execute;
end;

procedure TForm1.Logout1Click(Sender: TObject);
begin
   uilSecurityManager1.Logout;
end;

procedure TForm1.uilSecurityManager1DisabledLogin(Sender: TObject;
  UserName: String);
begin
   ShowMessage(Username + ' is a diabled user.');
end;

procedure TForm1.EditCopy1Execute(Sender: TObject);
begin
   // This is a dummy event
end;

end.
